; sMac/theme.jl

(let*
  (
    (font-colors (list "Black"
                       "Black"))
                       
    (title-width
      (lambda (w)
        (let
          ((w-width (car (window-dimensions w))))
       (+ 5 (max 0 (+ 20 (min (- w-width 74) (text-width (window-name w)))))))))
        
    (half-title-width
       (lambda (w)
         (/ (title-width w) 2)))
         
    (title-position
       (lambda (w)
          (- (/ (car (window-dimensions w)) 2) (half-title-width w)) ))
          
    (update-title-width
      (lambda (w)
        (if (eq (window-get w 'current-frame-style) 'sMac) 
          (rebuild-frame w))))
    
    (close-button-image (list (make-image "btn_close_normal.png")
                               nil nil
                              (make-image "btn_close_clicked.png")))
    (maximize-button-image (list (make-image "maximize.png")
                                  nil nil
                                 (make-image "maximize-click.png")))
    (shade-button-image (list (make-image "btn_shade_normal.png")
                               nil nil
                              (make-image "btn_shade_clicked.png")))

    (left-image (list (make-image "unsel_lborder.png") (make-image "sel_lborder.png")))
    (right-image (list (make-image "unsel_rborder.png") (make-image "sel_rborder.png")))
    (middle-image (list (make-image "unsel_titlebar.png") (make-image "sel_titlebar.png")))
;;    (left-title-area (list (make-image "unsel_titlebar.png")
;;                            (make-image "sel_titlebar.png")))
    (middle-title-area (list (make-image "unsel_titlebar_text.png")
                              (make-image "sel_titlebar_text.png")))
;;    (right-title-area (list (make-image "unsel_titlebar.png")
;;                             (make-image "sel_titlebar.png")))
    (bottom-rt-corner-scale (list (make-image "unsel_scale1.png") (make-image "sel_scale1.png")))

    (bottom-rt-corner (list (make-image "unsel_lrcorner.png") (make-image "sel_lrcorner.png")))
    (bottom-lt-corner (list (make-image "unsel_llcorner.png") (make-image "sel_llcorner.png")))
(bottom (list (make-image "unsel_btmborder.png") (make-image "sel_btmborder.png")))
(top (list (make-image "unsel_top.png") (make-image "sel_top.png")))
(t-tl (make-image "trans-topleft.png"))
(t-tr (make-image "trans-topright.png"))
(s-tr (make-image "s-topright.png"))
(s-tl (make-image "s-topleft.png"))
(tr (make-image "topright.png"))
(tl (list (make-image "topleft-sel.png") (make-image "topleft.png")))

    (frame `(
        ((background . ,middle-image)
         (left-edge . 0)
         (right-edge . 0)
         (top-edge . -21)
         (class . title))
        
	((background . ,tr)
	 (right-edge . -7)
	 (top-edge . -21)
	 (class . top-right-corner))
	
	((background . ,tl)
	 (left-edge . -6)
	 (top-edge . -21)
	 (class . top-left-corner))
         
;;        ((background . ,left-title-area)
;;         (left-edge . ,(lambda (w) (- (title-position w) 8)))
;;         (top-edge . -21)
;;	 (height . 21)
;;         (class . title))
         
        ((background . ,middle-title-area)
         (left-edge . ,(lambda (w) (title-position w)))
         (right-edge . ,(lambda (w) (title-position w)))
         (top-edge . -21)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
	(font . "-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-1") 
         (class . title))
         
;;        ((background . ,right-title-area)
;;         (right-edge . ,(lambda (w) (- (title-position w) 8)))
;;         (top-edge . -21)
;;         (height . 21)
;;	 (class . title))
                
        ((background . ,close-button-image)
         (left-edge . 4)
         (top-edge . -17)
         (class . close-button))

        ((background . ,shade-button-image)
         (right-edge . 4)
         (top-edge . -17)
         (class . iconify-button))
         
        ((background . ,maximize-button-image)
         (right-edge . 19)
         (top-edge . -17)
         (class . maximize-button))
         
  
                 
        ((background . ,left-image)
         (left-edge . -6)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . left-border))
         
        ((background . ,right-image)
         (right-edge . -7)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . right-border))        
         
        ((background . ,bottom)
         (left-edge . 0)
         (right-edge . 0)
         (bottom-edge . -7)
         (class . bottom-border))
         
        ((background . ,bottom-lt-corner)
         (left-edge . -6)
         (bottom-edge . -7)
         (class . bottom-left-corner))
         
        ((background . ,bottom-rt-corner-scale)
         (right-edge . -7)
         (bottom-edge . -7)
         (class . bottom-right-corner))
         
      ))
      
    (shaped-frame `(
        ((background . ,middle-image)
         (left-edge . 0)
         (right-edge . 0)
         (top-edge . -21)
         (class . title))
         
	((background . ,s-tl)
	 (left-edge . -6)
	 (top-edge . -21)
	 (class . top-left-corner))


	((background . ,s-tr)
	 (right-edge . -7)
	 (top-edge . -21)
	 (class . top-right-corner))

         
;;        ((background . ,left-title-area)
;;         (left-edge . ,(lambda (w) (- (title-position w) 8)))
;;         (top-edge . -21)
;;	 (height . 21)
;;         (class . title))
         
         
        ((background . ,middle-title-area)
         (left-edge . ,(lambda (w) (title-position w)))
         (right-edge . ,(lambda (w) (title-position w)))
         (top-edge . -21)
	(font . "-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-1") 
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (class . title))
         
;;        ((background . ,right-title-area)
;;         (right-edge . ,(lambda (w) (- (title-position w) 8)))
;;         (height . 21)
;;	 (top-edge . -21)
;;         (class . title))
                
        ((background . ,close-button-image)
         (left-edge . 4)
         (top-edge . -17)
         (class . close-button))
         
        ((background . ,maximize-button-image)
         (right-edge . 19)
         (top-edge . -17)
         (class . maximize-button))
         
        ((background . ,shade-button-image)
         (right-edge . 4)
         (top-edge . -17)
         (class . iconify-button))                       
        
      ))

    (transient-frame `(
         
        ((background . ,left-image)
         (left-edge . -6)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . left-border))
         
        ((background . ,right-image)
         (right-edge . -7)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . right-border))        
         
        ((background . ,bottom)
         (left-edge . 0)
         (right-edge . 0)
         (bottom-edge . -7)
         (class . bottom-border))

         ((background . ,top)
         (left-edge . 0)
         (right-edge . 0)
         (top-edge . -6)
         (class . title))

        ((background . ,t-tl)
         (left-edge . -6)
         (top-edge . -6)
         (class . top-left-corner))
 

        ((background . ,bottom-lt-corner)
         (left-edge . -6)
         (bottom-edge . -7)
         (class . bottom-left-corner))

	 ((background . ,t-tr)
         (right-edge . -7)
         (top-edge . -6)
         (class . top-right-corner))

	 ((background . ,bottom-rt-corner)
         (right-edge . -7)
         (bottom-edge . -7)
         (class . bottom-right-corner))
         
      ))
      
    (shaped-transient-frame `(
        ((background . ,middle-image)
         (left-edge . 0)
         (right-edge . 0)
         (top-edge . -21)
         (class . title))
         
	((background . ,tr)
	 (right-edge . -6)
	 (top-edge . -21)
	 (class . top-right-corner))
	
	((background . ,tl)
	 (left-edge . -6)
	 (top-edge . -21)
	 (class . top-left-corner))

         
;;        ((background . ,left-title-area)
;;         (left-edge . ,(lambda (w) (- (title-position w) 8)))
;;	 (height . 21)
;;         (top-edge . -21)
;;         (class . title))
         
        ((background . ,middle-title-area)
         (left-edge . ,(lambda (w) (title-position w)))
         (right-edge . ,(lambda (w) (title-position w)))
         (top-edge . -21)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . center)
	(font . "-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-1") 
         (y-justify . center)
         (class . title))
         
;;        ((background . ,right-title-area)
;;         (right-edge . ,(lambda (w) (- (title-position w) 8)))
;;         (top-edge . -21)
;;	 (height . 21)
;;         (class . title))
                
        ((background . ,close-button-image)
         (left-edge . 4)
         (top-edge . -17)
         (class . close-button))
                
      ))


   )
      
  (add-frame-style 'sMac
    (lambda (w type)
      (cond 
            ((eq type 'shaped) shaped-frame)
            ((eq type 'shaded) shaped-frame)
            ((eq type 'unframed) nil-frame)
            ((eq type 'transient) transient-frame)
            ((eq type 'shaded-transient) shaped-transient-frame)
            ((eq type 'shaped-transient) shaped-transient-frame)
            (t frame))))    
            
  (call-after-property-changed 'WM_NAME update-title-width)        
)
